; LINKTEST.ASM - Program to read link port status.
; By Andrew Tipton - Feel free to use this in any way you please
;		     EXCEPT commercial use. :)
; Rewritten, recommented and recompiled for ASH 3.0 
;   by Larry Currie, Larry1492@juno.com

#include "ti82.h"
.org START_ADDR
.DB "Linktest 82 !", 0

	ROM_CALL(CLEARLCD)	;Clear LCD
	ld hl, $0000		;Load $0000 into register hl
	ld (CURSOR_POS),hl	;Load register hl into Row,Col RAM location
	ld hl,MainScrn		;Load text to display into hl
	ROM_CALL(D_ZT_STR)	;Display string (homescreen text) at location hl

LinkLoop:
	in a,(0)		;Read port 0
				;Bit 0(Red) & Bit 1(White) are 0=off, 1=on
	ld hl,$0C02		;Display at Row $02, Col $0C	
	ld (CURSOR_POS),hl	;Set the cursor to Row $02, Col $0C	
	bit 0,a			;Is bit 0 (red wire) on?
	jr nz,DisplayR0		;If not, goto DisplayR0
	ld a,$31		;$31 STO> a
	jr TestBit1		;Goto TestBit1

DisplayR0:
	ld a,$30		;$30 STO> a

TestBit1:
	ROM_CALL(TR_CHARPUT)	;Put character on display
	ld hl,$0C03		;Display at Row $03, Col $0C	
	ld ($800C),hl		;Set Cursor to ""  ""  ""
	in a,(0)		;getting something from linkport
	bit 1,a			;Is bit 1 (white wire) on?
	jr nz,DisplayW0		;If not, goto DisplayR0
	ld a,$31		;$31 STO> a
	jr KeyLoop		;goto KeyLoop
DisplayW0:
	ld a,$30
KeyLoop:
	ROM_CALL(TR_CHARPUT)	;Put character on display
	call GET_KEY		;Get a key from buffer
	cp $37			;Is it Quit?
	ret z			;If so, return
	jr LinkLoop		;Otherwise, check linkport status again

MainScrn:
	.db "--- LinkTest ---",
	.db "                ",
	.db "  Red Wire:     ",
	.db "White Wire:     ",
	.db "                ",
	.db "                ",
	.db "By Andrew Tipton",
	.db "(c) 1997       ",0	
.end
